/**
 * Copyright © 2019 František Kučera (Frantovo.cz, GlobalCode.info)
 *
 * This program is free software: you can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
 * even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program. If
 * not, see <http://www.gnu.org/licenses/>.
 */

#include <unistd.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <stdio.h>

/**
 * Otevře unixový doménový soket a napojí ho na FD 0 místo STDIN.
 * V Javě pak tento soket najdeme v System.inheritedChannel()
 * a můžeme na něm zavolat accept() a přijmout příchozí spojení.
 * 
 * program přeložíme pomocí: make start
 * 
 * // TODO: kontrolovat návratové hodnoty
 * 
 * @param argc
 * @param argv parametry javy (tenhle program používáme místo příkazu java)
 * @return 
 */
int main(int argc, char**argv) {

	struct sockaddr_un address;

	char* socket_name = "test.sock"; // TODO: maximální délka (sun_path)
	unlink(socket_name);

	memset(&address, 0x00, sizeof (address));
	address.sun_family = AF_UNIX;
	strncpy(address.sun_path, socket_name, sizeof(address.sun_path));

	int sock = socket(AF_UNIX, SOCK_STREAM, 0); // proud
	// int sock = socket(AF_UNIX, SOCK_DGRAM, 0); // datagramy
	bind(sock, (const struct sockaddr*) & address, sizeof (address));
	listen(sock, 100);

	int newStdOut = dup(0);
	dup2(sock, 0);
	
	dprintf(newStdOut, "Socket je na FD 0 a FD %d\n", sock);
	dprintf(newStdOut, "STDIN přesunut na   FD %d\n", newStdOut);
	
	// int client = accept(sock, NULL, NULL); // FD 5
	// dprintf(newStdOut, "přijaté spojení je  FD %d\n", client);

	execv("/usr/bin/java", argv);
}
